--
-- rootbucket

-- Specialization Bressel and Lade 1850 l light cargo shovel --
-- edit by Defender

-- edit by henly20 Ls-uk-info 11-8-2011


rootbucket = {};

function rootbucket.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations) and SpecializationUtil.hasSpecialization(Fillable, specializations);
end;

function rootbucket:load(xmlFile)
    self.tipReferencePoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tipReferencePoint#index"));
    if self.tipReferencePoint == nil then
        self.tipReferencePoint = self.components[1].node;
    end;
	
	self.fallOut = false;
	self.fallOut2 = false;
	self.fallOutParticle = false;
	self.implementFallOut = true;
	self.isShovel = true;
	self.lastFillLevel = self.fillLevel;

end;

function rootbucket:delete()
end;

function rootbucket:mouseEvent(posX, posY, isDown, isUp, button)
end;

function rootbucket:keyEvent(unicode, sym, modifier, isDown)
end;

function rootbucket:update(dt)
end;

function rootbucket:updateTick(dt)
    if self:getIsActive() then
		self.fallOut2 = false;
		if self.attacherVehicle ~= nil then
			self.fallOut2 = false;
				local x,y,z = localDirectionToWorld(self.tipReferencePoint, 0,0,1);
				if y < -0.5 or self.rotationShovelMax then
					self.fallOut = true;
				else
					self.fallOut = false;
				end;
				self.tiltangle = y;
		end;
		if self.fallOut and self.implementFallOut  then
			self:setFillLevel(self.fillLevel, self.currentFillType);
			local nearestDistance = 5.0;
			local px, py, pz = getWorldTranslation(self.tipReferencePoint);
			for i=1, table.getn(g_currentMission.attachables) do
				local vx, vy, vz = getWorldTranslation(g_currentMission.attachables[i].rootNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					local attachable = g_currentMission.attachables[i];		
					if attachable.fillTypes ~= nil and attachable.setFillLevel ~= nil and attachable.fillLevel ~= nil and attachable ~= self then
						if self.currentFillType == attachable.currentFillType or attachable.currentFillType == FruitUtil.FRUITTYPE_UNKNOWN then
							if attachable.fillLevel < attachable.capacity  and self.fillLevel > 1 then							
								local deltaLevel = (self.tiltangle*self.tiltangle)*(self.capacity/200)*dt							
								local fillDelta = math.min(deltaLevel, self.fillLevel)
								self:setFillLevel(self.fillLevel - fillDelta, self.currentFillType);
								attachable:setFillLevel(attachable.fillLevel + fillDelta, self.currentFillType);
								self.fallOut2 = self.fillLevel>0 and fillDelta>0;						
							end; 
						end;
					end;
				end;
			end;
		end;
		if self.fillLevel == 0 then
			self.currentFillType = FruitUtil.FRUITTYPE_UNKNOWN;
		end;
		if self.lastFillLevel > self.fillLevel then
			self.fallOutParticle = true;
		else
			self.fallOutParticle = false;
		end;
		self.lastFillLevel = self.fillLevel;
			
		Utils.setEmittingState(self.dischargeParticleSystems[self.currentFillType], self.fallOutParticle);
		
		if self.tipState == Trailer.TIPSTATE_OPENING or self.tipState == Trailer.TIPSTATE_CLOSING or self.tipState == Trailer.TIPSTATE_OPEN then
			Utils.setEmittingState(self.dischargeParticleSystems[self.currentFillType]);
			self.fallOut = true;
			self.fallOut2 = true;
			self.implementFallOut = true;
			self.isShovel = false;
		else
			self.fallOut = false;
			self.fallOut2 = false;
			self.implementFallOut = true;
			self.isShovel = true;
		end;
	end;
end;

function rootbucket:draw()
end;

function rootbucket:onDetach()
   if self.deactivateOnDetach then
        rootbucket.onDeactivate(self);
    end;
	self.fallOutParticle = false;
end;

function rootbucket:toggleTipState()
end;

function rootbucket:onDeactivate()
    self.fallOut = false;
end;